// CLOCK options

//`define USE_DMY_CLOCK		// using only 1 input
//`define SYS_DRIVEN_CLK4PH	// using 4 phase clock

`ifdef SYS_DRIVEN_CLK4PH
  `define posedge_CLK_0		posedge CLK_0
  `define posedge_CLK_90	posedge CLK_90
  `define posedge_CLK_180	posedge CLK_180
  `define posedge_CLK_270	posedge CLK_270
  `define posedge_CLK_0_180	posedge CLK_0_180
  `define posedge_CLK_90_270	posedge CLK_90_270
`else // SYS_DRIVEN_CLK2X
  `define posedge_CLK_0		negedge CLK2X
  `define posedge_CLK_90	posedge CLK2X
  `define posedge_CLK_180	negedge CLK2X
  `define posedge_CLK_270	posedge CLK2X
  `define posedge_CLK_0_180	negedge CLK2X
  `define posedge_CLK_90_270	posedge CLK2X
`endif

// SMP definition (Privete Space == Processor Specific DATA )
//                 : default 512B + 512B  
//`define PS4K  // Private Space is 4KB+4KB 
//`define PS2K  // Private Space is 2KB+2KB 
//`define PS1K  // Private Space is 1KB+1KB 

// using only 1 port for ROM access : need for SMP
//`define ROM_PSEUDO_DP
// 
//`define SUPPORT_LOCKING
//`define IOR_DUALPORT
//`define IOR_HAVE_CPI0
//`define RAM_HAVE_PORTA
//`define ROM_HAVE_PORTCD

// CORE definition
//`define SUPPORT_LDST32  // +13 - +24 slices : not recommended
`define SUPPORT_LDD	  // reduced ver (31 >= disp >= 0) : default
//`define SUPPORT_ISP

`define USE_GPR_16	  // use shrinked version for GPR

`define STALL_WB_CONFLICT_3
//  - STALL r26-r31 WB inst + INDEX X/Y/Z inst

// performance (Max CLK) tuning
//`define NEXTPC_TUNE	//
//`define EA_TUNE	// 
`define ALU_EXTENDED

`define IOR_LARGE_MAPPER

// don't use OE_RAM / OE_RAM
`define OUTPUT_MUX_NONE

// mux by or IOR sub-modules
`define OUTPUT_MUX_OR

// GPR build options
`define GPR_INITCLR

//`define RTAVR_PORT_ESCALATION		// RTAVR is sub-module
`define IOR_PORT_ESCALATION		// IOR is sub-module

// top layer configuration
`define RTAVR_INCLUDE_IOR
`define RTAVR_INCLUDE_RAM
`define RTAVR_INCLUDE_ROM
`define RTAVR_INCLUDE_INTCONT

`define PRC_WATCH		// (debug option)
`define PRC_WATCH_WDR		// (debug option)
//`define PRC_WATCH_P1		// (debug option)
//`define PRC_WATCH_SMP		// (debug option)

// IOR configuration
//`define IOR_HAVE_GPIOR0
//`define IOR_HAVE_GPIOR1
//`define IOR_HAVE_GPIOR2
`define IOR_HAVE_PORTA
`define IOR_HAVE_PORTB
`define IOR_HAVE_PORTC
`define IOR_HAVE_SREG_SP
//`define FIXED_SPH	0	// fixed SPH (-19 slices)
//`define IOR_SPHBITS	2	// SPH bits 1-8 (-15 slices)
`define IOR_HAVE_INT0
`define IOR_HAVE_INT1
//`define IOR_HAVE_RAMWIN	// notyet
//`define IOR_HAVE_RAMWIN_HA	// hi-addr
`define IOR_HAVE_NVM
  `define NVM_RAM_PROTECT
`define IOR_HAVE_TIM0
`define IOR_HAVE_TIM0_OC0A
`define IOR_HAVE_TIM0_OC0B
//`define IOR_NO_COMPA   // tempolary shrinking option
//`define IOR_NO_COMPB   // tempolary shrinking option
`define IOR_HAVE_SPI
`define IOR_HAVE_USART
// `define IOR_HAVE_TWI 	// notyet
//`define IOR_HAVE_CPI1

// CPI (Communication Port Interface0 configuration
  `ifdef IOR_HAVE_CPI0
    `define IOR_HAVE_CPI
  `elsif IOR_HAVE_CPI1
    `define IOR_HAVE_CPI
  `endif

// SRAM configuration

`define SRAM_INITCLR  //  default
// use ram_data.dat (using $readmemh)
// `define RAM_INCLUDE_DAT
// use ram_data.v
//`define RAM_INCLUDE_V

`define RAM_SIZE 2048
//`define RAM_SIZE 4096
//`define RAM_SIZE 8192

// ROM configuration

// use rom_data.dat (using $readmemh) default
`define ROM_INCLUDE_DAT
// use rom_data.v
//`define ROM_INCLUDE_V

//`define ROM_SIZE 1024
`define ROM_SIZE 2048
//`define ROM_SIZE 4096

// PORT configuration
`define PORT_HAVE_PIN_WRITE	// toggle func (+4 slices)

// TIM0 configuration
//`define TIM0_EXPORT_PS	// using when other timer is used
//`define FIXED_CS0	3	// Prescaler 1: 1/1 2: 1/8 3: 1/64
				//           4: 1/256 5: 1/1024
				//   stop : write 0 set: write other val
//`define FIXED_WGM0	0	//
//`define FIXED_COM0B	0	//
//`define FIXED_COM0A	0	//
//`define FIXED_OCR0B	127	//
//`define FIXED_OCR0A	128	//


// USART configuration
//`define USART_LOCAL_LB
//`define FIXED_MPCM	0	// 0: 
//`define FIXED_U2X	1	// prescaler option
//`define FIXED_UMSEL	0	// 0: async 1:sync 3: spi master
//`define FIXED_UPM	0	// parity 0: none 2: even 3: odd
//`define FIXED_USBS	0	// stop-bit 0: st1 1: st2
//`define FIXED_UCSZ	3	// 2: 7bit 3: 8bit 7: 9bit
//`define FIXED_UDORD	0	// 0: LSB first 1: MSB first (only in spi)
//`define FIXED_UCPHA	0	// clock phase 0: IN-SFT 1: SFT-IN (only in spi)
//`define FIXED_UCPOL	0	// clock polarity 0: normal 1: reversed
//`define FIXED_UBRR	106	// boud parameter (Max 12bit) 19.2k @ 16.5 MHz
//`define FIXED_UBRR	28	// boud parameter (Max 12bit) 19.2k @  6 MHz
//`define FIXED_UBRR	25	// boud parameter (Max 12bit) 19.2k @  4 MHz
//`define UBRR_BITS	8	// boud parameter (2 - 16)


// SPI configuration
`define SPI_HAVE_WCOL
`define SPI_HAVE_PSV_SS
//`define FIXED_MSTR	1 	// 1: Master 0: Slave
//`define FIXED_DORD	0 	// 0: MSB first 1: LSB first
//`define FIXED_CPOL	0	// 0: Noraml SCK , 1: Reversed SCK
//`define FIXED_CPHA	0	// 0:IN_ SFT order , 1: SFT_IN order
//`define FIXED_SPR	0	// 0: 1/2 CLK , 1: 1/4 CLK 2: 1/8 CLK
				// 3: 1/16 CLK , 4: 1/32 CLK 5,6: 1/64 CLK
				// 7: 1/128 CLK 

// 
`define INT0_vect_num            1
`define INT1_vect_num            2
//`define INT2_vect_num            3
//`define INT3_vect_num            4
`define CPI0_vect_num            5
`define CPI1_vect_num            6
`define TIM0_COMPA_vect_num     11
`define TIM0_COMPB_vect_num     12
`define TIM0_OVF_vect_num       13
`define USART_TX_vect_num       14
`define USART_UDRE_vect_num     15
`define TWI_SLAVE_vect_num      16
`define SPI_vect_num            17
`define USART_RX_vect_num       18

`define	 PORTA_ADDR  6'h00   // PINA 0x00 , DDRA, PORTA
`define	 PORTB_ADDR  6'h04   // PINB 0x04 , DDRB, PORTB
`define	 PORTC_ADDR  6'h1b   // PINC 0x1b , DDRC, PORTC
`define	 RAMWIN_ADDR 6'h1f   // RAMDR 0x1f , RAMAR 0x20
`define	 TIM0_ADDR   6'h15   // OCR0B 0x15 - TCCR0A 0x19
`define	 SREG_ADDR   6'h3f   // SREG 0x3f , SPH,SPL,CCP,RSRFR,MCUCR 0x3a
`define	 MCUCR_ADDR  6'h3a   // MCUCR 0x3a
`define	 GIFR_ADDR   6'h0b   // GIFR 0x0b , GIMSK 0x0c
`define	 TIFR_ADDR   6'h25   // TIFR 0x25 , TIMSK 0x26  
`define	 NVM_ADDR    6'h32   // NVMCSR 0x32 , NVMCMD 0x33  
`define	 USART_ADDR  6'h0e   // USART : (0x0e - 0x14 ADC space)
`define	 SPI_ADDR    6'h2e    // SPI : SPDR 0x2e, SPSR, SPCR
`define	 TWI_ADDR    6'h28    // TWI : TWSD 0x28, TWSAM,TWSA, TWSSRA
`define	 CPI0_ADDR   6'h36    // CPI0 : CPCSR0 0x36, CPDR0
`define	 CPI1_ADDR   6'h34    // CPI1 : CPCSR1 0x34, CPDR1

`define	 GPIOR0_ADDR  6'h03   // 
`define	 GPIOR1_ADDR  6'h07   // 
`define	 GPIOR2_ADDR  6'h08   // 


`define PORT_IGNORE_COND		(0)
`define PORT_IGNORE_OUTPUT_COND		(i == 21)

`define	 INT0_BIT  18     // PC2
`define	 INT1_BIT  10     // PB2
`define	 OC0A_BIT  16     // PC0
`define	 OC0B_BIT   5     // PA5
`define	 SS_BIT    16     // PC0
`define	 SCK_BIT   17     // PC1
`define	 MOSI_BIT  20     // PC4
`define	 MISO_BIT  18     // PC2
`define	 RX_BIT    21     // PC5
`define	 TX_BIT    22     // PC6
`define	 XCK_BIT   23     // PC7
`define	 SDA_BIT   20     // PC4
`define	 SCL_BIT   17     // PC1
